src/main/java/mycontrollers/MyCarController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mycontrollers;

import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.servlet.http.Part;
import myfacades.MyCarFacade;
import org.apache.commons.io.FilenameUtils;
import org.apache.commons.io.IOUtils;
import org.csd322.entities.Car;
import org.csd322.sessionbeans.CarFacade;

/**
 *
 * @author fred
 */
@Named(value = "myCarController")
@SessionScoped
public class MyCarController implements Serializable {

    @EJB
    private CarFacade facade;
    @EJB
    private MyCarFacade myFacade;

    private Car current;
    private Filter filter;
    private Part file;
    private String filename;
    private String extension;
    private String namedQuery;
    private Integer year;
    // See https://www.mkyong.com/jsf2/jsf-2-dropdown-box-example/
    private static Map<String, Object> types;

    static {
        types = new LinkedHashMap<>();
        types.put("Sedan", "Sedan"); //label, value
        types.put("Coupe", "Coupe");
        types.put("Cargo Van", "Cargo Van");
        types.put("Hatchback", "Hatchback");
        types.put("Passenger Van", "Passenger Van");
        types.put("Pickup", "Pickup");
        types.put("SUV", "SUV");
    }

    public Map getTypes() {
        return types;
    }

    /**
     * Creates a new instance of MyCarController
     */
    public MyCarController() {
    }

    public void setQuery() {

    }

    public String getAudioFile() {
        return "<audio src='mi.mp3' controls=''/>";//    autoplay='off'/>";
    }

    public String submit() {
//        setCurrent(new Car());
//        getFacade().create(getCurrent());

        final String fileName = getFile().getName();
        InputStream filecontent;
        byte[] bytes = null;
        try {
            filecontent = getFile().getInputStream();
            int read = 0;

            // IOUtils.toByteArray(filecontent); // Apache commons IO.
            getCurrent().setImage(IOUtils.toByteArray(filecontent));

            //while ((read = filecontent.read(current.getImage())) != -1) {
//            }
            getFacade().edit(getCurrent());
        } catch (IOException ex) {
            Logger.getLogger(MyCarController.class.getName()).log(Level.SEVERE, null, ex);
        }
        setFilename(FilenameUtils.getBaseName(getFile().getSubmittedFileName()));
        setExtension(FilenameUtils.getExtension(getFile().getSubmittedFileName()));
        return "jsfUpload";
    }

    public byte[] getBytes() {
        byte[] b = new byte[0];
        if (getCurrent() != null) {
            Car i = facade.find(getCurrent().getId());
            byte[] img = i.getImage();
            if (img == null) {
                return b;
            }
            return img;
        } else {
            return b;
        }
    }

    public List<Car> getCars() {
        if (getNamedQuery() != null && getNamedQuery().equals("Car.findByMake")) {
            return myFacade.findByMake(filter.getMake());
        }
        if (getNamedQuery() != null && getNamedQuery().equals("Car.findByModel")) {
            return myFacade.findByModel(filter.getModel());
        }
        if (getNamedQuery() != null && getNamedQuery().equals("Car.findByYear")) {
            return myFacade.findByYear(filter.getYear());
        }
        if (getNamedQuery() != null && getNamedQuery().equals("Car.findByMileage")) {
            return myFacade.findByMileage(filter.getMileageFrom(), filter.getMileageTo());
        }
        if (getNamedQuery() != null && getNamedQuery().equals("Car.findBySellingPrice")) {
            return myFacade.findBySellingPrice(filter.getSellingPriceFrom(), filter.getSellingPriceTo());
        }

        List<Car> list = null;
        list = getFacade().findAll();
        return list;
    }

    public String edit(Car car) {
        setCurrent(car);
        return "Edit";
    }

    public String create() {
        Car c = new Car();
        facade.create(c);
        return edit(c);
    }

    public String update() {
        getFacade().edit(getCurrent());
        return "Main";
    }

    public String delete(Car car) {
        getFacade().remove(car);
        return "Main";
    }

    /**
     * @return the facade
     */
    public CarFacade getFacade() {
        return facade;
    }

    /**
     * @param facade the facade to set
     */
    public void setFacade(CarFacade facade) {
        this.facade = facade;
    }

    /**
     * @return the current
     */
    public Car getCurrent() {
        return current;
    }

    /**
     * @param current the current to set
     */
    public void setCurrent(Car current) {
        this.current = current;
    }

    /**
     * @return the file
     */
    public Part getFile() {
        return file;
    }

    /**
     * @param file the file to set
     */
    public void setFile(Part file) {
        this.file = file;
    }

    /**
     * @return the filename
     */
    public String getFilename() {
        return filename;
    }

    /**
     * @param filename the filename to set
     */
    public void setFilename(String filename) {
        this.filename = filename;
    }

    /**
     * @return the extension
     */
    public String getExtension() {
        return extension;
    }

    /**
     * @param extension the extension to set
     */
    public void setExtension(String extension) {
        this.extension = extension;
    }

    /**
     * @return the namedQuery
     */
    public String getNamedQuery() {
        return namedQuery;
    }

    /**
     * @param namedQuery the namedQuery to set
     */
    public void setNamedQuery(String namedQuery) {
        if (namedQuery.isEmpty()) {
            filter = new Filter();
        }
        this.namedQuery = namedQuery;
    }

    /**
     * @return the filter
     */
    public Filter getFilter() {
        if (filter == null) {
            filter = new Filter();
        }
        return filter;
    }

    /**
     * @param filter the filter to set
     */
    public void setFilter(Filter filter) {
        this.filter = filter;
    }

    /**
     * @return the year
     */
    public Integer getYear() {
        Date yr = current.getYear();
        if (yr == null) {
            return null;
        }
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(yr);
        year = calendar.get(Calendar.YEAR);
        return year;
    }

    /**
     * @param year the year to set
     */
    public void setYear(Integer year) {
        this.year = year;
        Date yr = current.getYear();
        if (yr == null) {
            yr = new Date();
        }
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(yr);
        calendar.set(Calendar.YEAR, year);
        current.setYear(calendar.getTime());
//        yr.setYear(year);
    }
    /*
        Date yr = current.getYear();
        if(yr==null)
            yr=new Date();
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(yr);
        calendar.set(Calendar.YEAR, year);
        yr.setYear(year);
     */

}

src/main/java/mycontrollers/MyPersonController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mycontrollers;

import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import javax.ejb.EJB;
import org.csd322.entities.Person;
import org.csd322.sessionbeans.PersonFacade;

/**
 *
 * @author fred
 */
@Named(value = "myPersonController")
@SessionScoped
public class MyPersonController implements Serializable {
    Person current;
    @EJB
    private PersonFacade facade;
    
    /**
     * Creates a new instance of MyPersonController
     */
    public MyPersonController() {
    }
    
}

src/main/java/mycontrollers/MySpecialController.java
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mycontrollers;

import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import java.util.List;
import javax.ejb.EJB;
import myfacades.MySpecialFacade;
import org.csd322.entities.Car;
import org.csd322.entities.Special;

/**
 *
 * @author fred
 */
@Named(value = "mySpecialController")
@SessionScoped
public class MySpecialController implements Serializable {

    @EJB
    MySpecialFacade facade;
    
    private Special current;
    private Car currentCar;
    
    public MySpecialController() {
    }
        public String edit(Special special) {
        setCurrent(special);
        return "Edit";
    }

    public String create() {
        Special c = new Special();
        facade.create(c);
        return edit(c);
    }

    public String update() {
        facade.edit(getCurrent());
        return "Main";
    }

    public String delete(Special special) {
        facade.remove(special);
        return "Main";
    }


    public List<Special> getSpecials(){
        return facade.findAll();
    }
    public List<Special> getSpecialsForSpecial(Car c){
        return facade.findSpecialsForCar(c);
    }

    /**
     * @return the current
     */
    public Special getCurrent() {
        return current;
    }

    /**
     * @param current the current to set
     */
    public void setCurrent(Special current) {
        this.current = current;
    }

    /**
     * @return the currentCar
     */
    public Car getCurrentCar() {
        return currentCar;
    }

    /**
     * @param currentCar the currentCar to set
     */
    public void setCurrentCar(Car currentCar) {
        this.currentCar = currentCar;
    }
}

src/main/java/org/csd322/jsfclasses/CarController.java
package org.csd322.jsfclasses;

import org.csd322.entities.Car;
import org.csd322.jsfclasses.util.JsfUtil;
import org.csd322.jsfclasses.util.PaginationHelper;
import org.csd322.sessionbeans.CarFacade;

import java.io.Serializable;
import java.util.ResourceBundle;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.SelectItem;

@Named("carController")
@SessionScoped
public class CarController implements Serializable {

    private Car current;
    private DataModel items = null;
    @EJB
    private org.csd322.sessionbeans.CarFacade ejbFacade;
    private PaginationHelper pagination;
    private int selectedItemIndex;

    public CarController() {
    }

    public Car getSelected() {
        if (current == null) {
            current = new Car();
            selectedItemIndex = -1;
        }
        return current;
    }

    private CarFacade getFacade() {
        return ejbFacade;
    }

    public PaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new PaginationHelper(10) {

                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public DataModel createPageDataModel() {
                    return new ListDataModel(getFacade().findRange(new int[]{getPageFirstItem(), getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public String prepareList() {
        recreateModel();
        return "List";
    }

    public String prepareView() {
        current = (Car) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "View";
    }

    public String prepareCreate() {
        current = new Car();
        selectedItemIndex = -1;
        return "Create";
    }

    public String create() {
        try {
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("CarCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String prepareEdit() {
        current = (Car) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "Edit";
    }

    public String update() {
        try {
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("CarUpdated"));
            return "View";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String destroy() {
        current = (Car) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        performDestroy();
        recreatePagination();
        recreateModel();
        return "List";
    }

    public String destroyAndView() {
        performDestroy();
        recreateModel();
        updateCurrentItem();
        if (selectedItemIndex >= 0) {
            return "View";
        } else {
            // all items were removed - go back to list
            recreateModel();
            return "List";
        }
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("CarDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
        }
    }

    private void updateCurrentItem() {
        int count = getFacade().count();
        if (selectedItemIndex >= count) {
            // selected index cannot be bigger than number of items:
            selectedItemIndex = count - 1;
            // go to previous page if last page disappeared:
            if (pagination.getPageFirstItem() >= count) {
                pagination.previousPage();
            }
        }
        if (selectedItemIndex >= 0) {
            current = getFacade().findRange(new int[]{selectedItemIndex, selectedItemIndex + 1}).get(0);
        }
    }

    public DataModel getItems() {
        if (items == null) {
            items = getPagination().createPageDataModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    private void recreatePagination() {
        pagination = null;
    }

    public String next() {
        getPagination().nextPage();
        recreateModel();
        return "List";
    }

    public String previous() {
        getPagination().previousPage();
        recreateModel();
        return "List";
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), true);
    }

    public Car getCar(java.lang.Integer id) {
        return ejbFacade.find(id);
    }

    @FacesConverter(forClass = Car.class)
    public static class CarControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            CarController controller = (CarController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "carController");
            return controller.getCar(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof Car) {
                Car o = (Car) object;
                return getStringKey(o.getId());
            } else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + Car.class.getName());
            }
        }

    }

}

src/main/webapp/app/car/Main.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:o="http://omnifaces.org/ui"
      xmlns:of="http://omnifaces.org/functions"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
    <h:head>
        <title>Used Car Lot</title>
    </h:head>
    <h:body>
        <h:form>
            <h:link value="Home..." outcome="/index"/>
            <br/>
            <h:commandButton action="#{myCarController.create()}" value="New Car..."/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByMake')}" value="Find by Make"/>
            <h:inputText value="#{myCarController.filter.make}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByModel')}" value="Find by Model"/>
            <h:inputText value="#{myCarController.filter.model}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByYear')}" value="Find by Year"/>
            <h:inputText value="#{myCarController.filter.year}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByMileage')}" value="Find by Mileage"/>
            From:<h:inputText value="#{myCarController.filter.mileageFrom}"/>
            To:<h:inputText value="#{myCarController.filter.mileageTo}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findBySellingPrice')}" value="Find by Selling Price"/>
            From:<h:inputText value="#{myCarController.filter.sellingPriceFrom}"/>
            To:<h:inputText value="#{myCarController.filter.sellingPriceTo}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>

        </h:form>
        <h:form>
            <h:dataTable bgcolor="#cecece" border="1" value="#{myCarController.cars}" var="car">
                <h:column>
                    <f:facet name="header">Make</f:facet>
                    <h:outputText value="#{car.make}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Model</f:facet>
                    <h:outputText value="#{car.model}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Year</f:facet>
                    <h:outputText value="#{car.year}">
                        <f:convertDateTime pattern="yyyy" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Type</f:facet>
                    <h:outputText value="#{car.type}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Image</f:facet>
                    <o:graphicImage width="200" value="#{car.image}" dataURI="true" />
                </h:column>
                <h:column>
                    <f:facet name="header">Pre-owned</f:facet>
                    <h:outputText value="#{car.used}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Odometer</f:facet>
                    <h:outputText value="#{car.odometerKm}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Selling Price</f:facet>
                    <h:outputText value="#{car.sellingPrice}">
                        <f:convertNumber pattern="¤#,##0.00" currencySymbol="$" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Bought For</f:facet>
                    <h:outputText value="#{car.boughtFor}">
                        <f:convertNumber pattern="¤#,##0.00" currencySymbol="$" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Sold For</f:facet>
                    <h:outputText value="#{car.soldFor}">
                        <f:convertNumber pattern="¤#,##0.00" currencySymbol="$" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Date Rec'd dd-MMM-yyyy</f:facet>
                    <h:outputText value="#{car.dateReceived}">
                        <f:convertDateTime pattern="dd-MMM-yyyy" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Date Sold dd-MMM-yyyy</f:facet>
                    <h:outputText value="#{car.dateSold}">
                        <f:convertDateTime pattern="dd-MMM-yyyy" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Specials <h:commandLink action="/app/specials/Main" value="(All)"/></f:facet>
                    <h:link rendered="#{!empty car.specialList}" value="Specials..."/>
                </h:column>
                <h:column><h:commandButton action="#{myCarController.edit(car)}" value="Edit..."/></h:column>
                <h:column><h:commandButton  onclick="return confirm('Are you sure?')" action="#{myCarController.delete(car)}" value="Delete..."/></h:column>
            </h:dataTable>
        </h:form>
    </h:body>
</html>

src/main/webapp/app/car/Main_1.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:o="http://omnifaces.org/ui"
      xmlns:of="http://omnifaces.org/functions"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
    <h:head>
        <title>Facelet Title</title>
    </h:head>
    <h:body>
        <h:form>
            <h:commandButton action="#{myCarController.create()}" value="New Car..."/>
            <h:dataTable value="#{myCarController.cars}" var="car">
                <h:column>
                    <f:facet name="header">Make</f:facet>
                    #{car.make}
                </h:column>
                <h:column>
                    <f:facet name="header">Model</f:facet>
                    #{car.model}
                </h:column>
                <h:column>
                    <f:facet name="header">Image</f:facet>
                    <o:graphicImage width="600" value="#{car.image}" dataURI="true" />
                </h:column>
                <h:column><h:commandButton action="#{myCarController.edit(car)}" value="Edit..."/></h:column>
            </h:dataTable>
        </h:form>
    </h:body>
</html>

src/main/webapp/app/car/Main_2.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:o="http://omnifaces.org/ui"
      xmlns:of="http://omnifaces.org/functions"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets">
    <h:head>
        <title>Facelet Title</title>
        <style type="text/css">
            div.inline { float:left; }
            .clearBoth { clear:both; }
        </style>
    </h:head>
    <h:body>
        <h:form>
            <h:commandButton action="#{myCarController.create()}" value="New Car..."/>
            <br/>
            <div style="border-style: dashed;color:red;">
                <ui:repeat value="#{myCarController.cars}" var="car">
                    <div class="inline">
                        <h:outputLabel value="#{car.make}"/>
                    </div>
                    <div class="inline">
                        <h:outputLabel value=" #{car.model}"/>
                    </div>
                    <div class="inline">
                        <h:outputLabel value=" #{car.year}"/>
                    </div>
                    <div class="inline">
                        <o:graphicImage width="400" value="#{car.image}" dataURI="true" />
                    </div>
                    <div class="inline">
                        <h:commandButton action="#{myCarController.edit(car)}" value="Edit..."/>
                    </div>
                </ui:repeat>
            </div>
        </h:form>
    </h:body>
</html>

src/main/webapp/app/car/Main_3.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:o="http://omnifaces.org/ui"
      xmlns:of="http://omnifaces.org/functions"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
    <h:head>
        <title>Used Car Lot</title>
    </h:head>
    <h:body>
        <h:form>
            <h:commandButton action="#{myCarController.create()}" value="New Car..."/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByModel')}" value="Find by Model"/>
            <h:inputText value="#{myCarController.filter.model}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByMake')}" value="Find by Make"/>
            <h:inputText value="#{myCarController.filter.make}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByYear')}" value="Find by Year"/>
            <h:inputText value="#{myCarController.filter.year}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:commandButton action="#{myCarController.setNamedQuery('Car.findByMileage')}" value="Find by Mileage"/>
            From:<h:inputText value="#{myCarController.mileageFrom}"/>
            To:<h:inputText value="#{myCarController.mileageTo}"/>
            <h:commandButton action="#{myCarController.setNamedQuery(null)}" value="Clear"/>
            <br/>
            <h:dataTable bgcolor="#cecece" border="1" value="#{myCarController.cars}" var="car">
                <h:column>
                    <f:facet name="header">Make</f:facet>
                    <h:outputText value="#{car.make}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Model</f:facet>
                    <h:outputText value="#{car.model}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Year</f:facet>
                    <h:outputText value="#{car.year}">
                        <f:convertDateTime pattern="yyyy" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Image</f:facet>
                    <o:graphicImage width="200" value="#{car.image}" dataURI="true" />
                </h:column>
                <h:column>
                    <f:facet name="header">Pre-owned</f:facet>
                    <h:outputText value="#{car.used}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Odometer</f:facet>
                    <h:outputText value="#{car.odometerKm}"/>
                </h:column>
                <h:column>
                    <f:facet name="header">Selling Price</f:facet>
                    <h:outputText value="#{car.sellingPrice}">
                        <f:convertNumber pattern="¤#,##0.00" currencySymbol="$" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Bought For</f:facet>
                    <h:outputText value="#{car.boughtFor}">
                        <f:convertNumber pattern="¤#,##0.00" currencySymbol="$" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Sold For</f:facet>
                    <h:outputText value="#{car.soldFor}">
                        <f:convertNumber pattern="¤#,##0.00" currencySymbol="$" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Date Rec'd dd-MMM-yyyy</f:facet>
                    <h:outputText value="#{car.dateReceived}">
                        <f:convertDateTime pattern="dd-MMM-yyyy" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Date Sold dd-MMM-yyyy</f:facet>
                    <h:outputText value="#{car.dateSold}">
                        <f:convertDateTime pattern="dd-MMM-yyyy" />
                    </h:outputText>
                </h:column>
                <h:column>
                    <f:facet name="header">Specials</f:facet>
                    <h:link rendered="#{!empty car.specialList}" value="Specials..."/>
                </h:column>
                <h:column><h:commandButton action="#{myCarController.edit(car)}" value="Edit..."/></h:column>
            </h:dataTable>
        </h:form>
    </h:body>
</html>